package 
{
	//TEST HARNESS SPELL MC
	import fl.motion.Tweenables;
	import fl.transitions.Tween;
	import flash.display.MovieClip;
	import fl.transitions.Tween;
	import fl.transitions.easing.*;
	import flash.geom.Point;
	import flash.display.DisplayObject;
	import flash.display.Stage;
	import fl.transitions.easing.Regular;
	/**
	 * ...
	 * @author Matt Roszak
	 */
	public class SpellMC extends MovieClip 
	{
		public var Battle:Object;
		
		public var spellcenter:MovieClip;
		public var X:Number;
		public var Y:Number;
		public var OX:Number;
		public var OY:Number;
		public var skin:int = 1;
		public var pointNumber:int = 1;
		public var selectedTarget:TestFoe;
		
		public function makeMagic(magic:Class, X:Number = 0, Y:Number = 0){
			var mc:MovieClip = new magic();
			parent.addChild(mc);
			
			mc.x = X;
			mc.y = Y;
			mc.skin = this.skin;
		}
		
		public function f2() { 
			
			if (parent.targetAll) {
				parent.targetAll = false;
				try {
					parent.f1.pauseNestedAnimations = true;
					parent.f2.pauseNestedAnimations = true;
					parent.f3.pauseNestedAnimations = true;
					
					parent.f1.gotoAndPlay("hit2");
					parent.f2.gotoAndPlay("hit2");
					parent.f3.gotoAndPlay("hit2");
					
					
				} catch (e:Error) {
					
					parent.p1.pauseNestedAnimations = true;
					parent.p2.pauseNestedAnimations = true;
					parent.p3.pauseNestedAnimations = true;
					
					parent.p1.gotoAndPlay("hit2");
					parent.p2.gotoAndPlay("hit2");
					parent.p3.gotoAndPlay("hit2");
				}
			} else {
				this.selectedTarget.pauseNestedAnimations = true;
				this.selectedTarget.gotoAndPlay("hit2");
			}
		}
		
		public function f3() { 
			
			if (parent.targetAll) {
				parent.targetAll = false;
				parent.p1.pauseNestedAnimations = true;
				parent.p2.pauseNestedAnimations = true;
				parent.p3.pauseNestedAnimations = true;
				
				parent.f2.gotoAndPlay("heal");
				parent.f3.gotoAndPlay("heal");
				parent.f1.gotoAndPlay("heal");
			} else {
				parent.selectedTarget.pauseNestedAnimations = true;
				parent.selectedTarget.gotoAndPlay("heal");
			}
		}
		
		public function SpellMC() {
			Battle = { shake:function(s:String = "small") { parent.shaker.gotoAndPlay(s); }, currentPlayer:null, bonusSpell:function(){}, visibleFoes:function(){}, hidePlayers:function(){}, showPlayers:function(){}, invisibleFoes:function(){}, visiblePlayers:function(){}, invisiblePlayers:function(){} };
			
		}
		
		public function drainage(){
			
		}
		
		public function init(targets:String, aimPoint:int) {
			OX = this.x;
			OY = this.y;
			this.selectedTarget = parent.selectedTarget;
			//skin = 1;
			
			pointNumber = aimPoint;
			
			if ( targets == Target.ALL_ALLY || targets == Target.ALL_ENEMY || targets == Target.ALL ) {
				//x = -spellcenter.x * flip; //+40
				//if ( (!Skills.user.isPlayer ) || extraFlip) x += 700;
				//y = -spellcenter.y;
				x = 0;
				y = 0;
			} else{
				positionOnTarget();
			}
			
			/*
			//aim at single target
			if ( targets == Target.ONE_ALLY || targets == Target.ONE_ENEMY || targets == Target.CENTER_ENEMY ) {	
				x = Battle.selectedTarget.graphic.getX(aim) - spellcenter.x*flip;
				y = Battle.selectedTarget.graphic.getY(aim) - spellcenter.y;

				if (Battle.selectedTarget.graphic) 
					parent.setChildIndex(this, parent.getChildIndex(Battle.selectedTarget.graphic) + 1);	//swap depths
			}
			
			//aim at all foes or all players
			if ( targets == Target.ALL_ALLY || targets == Target.ALL_ENEMY || targets == Target.ALL ) {
				x = -spellcenter.x * flip; //+40
				if ( (!Skills.user.isPlayer ) || extraFlip) x += 700;
				y = -spellcenter.y;
			}
			
			extraFlip = false;
			*/
		}
		
		public function hideAll() {
			parent.p1.visible = false;
			parent.p2.visible = false;
			parent.p3.visible = false;
			
			parent.f1.visible = false;
			parent.f2.visible = false;
			parent.f3.visible = false;
		}
		
		public function showAll() {
			parent.p1.visible = true;
			parent.p2.visible = true;
			parent.p3.visible = true;
			
			parent.f1.visible = true;
			parent.f2.visible = true;
			parent.f3.visible = true;
		}
		
		
		public function k() {
			stop();
			parent.removeChild(this);
			
		}
		
		var moveOut:Boolean = true;
		public function resetXY() {
			moveOut = false;
			X = OX;
			Y = OY;
		}
		
		//spell appears behind all targets on battlefield
		public function gotoBackLayer() {
			parent.setChildIndex(this, parent.getChildIndex(parent.bg) + 1); 
		}
		
		public function setXY() {
			moveOut = true;
			target = parent.selectedTarget;
			//target = parent.p3;
			X = (target as MovieClip).localToGlobal(new Point(target["point" + pointNumber].x, target["point" + pointNumber].y)).x;
			Y = (target as MovieClip).localToGlobal(new Point(target["point" + pointNumber].x, target["point" + pointNumber].y)).y;
		}
		
		//do nothing if already positioned
		public function positionOnTarget(offset:Number = 0 ) {
			//return;
			if(x == 0 && y == 0){
				setXY();
				x = X + offset - this.localToGlobal(new Point(spellcenter.x, spellcenter.y)).x + this.x;
				y = Y  - this.localToGlobal(new Point(spellcenter.x, spellcenter.y)).y + this.y;
			}
		}
		
		public function randomizeRotation() {
			this.rotation = 360 * Math.random();
		}
		
		public var tween1:Tween;
		public var tween2:Tween;
		
		//tween this to target
		public function move(offset:Number, frames:int, easing:Function) {
			if(moveOut){
				tween1 = new Tween(this, "x", easing, this.x, X + offset - this.localToGlobal(new Point(spellcenter.x, spellcenter.y)).x + this.x, frames);
				tween2 = new Tween(this, "y", easing, this.y, Y  - this.localToGlobal(new Point(spellcenter.x, spellcenter.y)).y + this.y, frames);
			} else {
				tween1 = new Tween(this, "x", easing, this.x, X + offset, frames);
				tween2 = new Tween(this, "y", easing, this.y, Y, frames);
			}
		}
		
	}
	
}